//
//  TinstallPlugin.m
//  Runner
//
//  Created by fx on 2021/5/31.
//

#import "TinstallPlugin.h"
#import <TInstallSDK/TInstallSDK.h>

@implementation TinstallPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar> *)registrar {
    FlutterMethodChannel *channel = [FlutterMethodChannel methodChannelWithName:@"tinstall_flutter_plugin" binaryMessenger:[registrar messenger]];
    TinstallPlugin *plugin = [TinstallPlugin new];
    [registrar addMethodCallDelegate:plugin channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    if ([@"init" isEqualToString:call.method]) {
        NSString *appkey = [call.arguments valueForKey:@"appKey"];
        [TInstall init:appkey];
        result(nil);
    } else if ([@"setHost" isEqualToString:call.method]) {
        NSString *host = [call.arguments valueForKey:@"host"];
        [TInstall setHost:host];
        result(nil);
    } else if ([@"getInstall" isEqualToString:call.method]) {
        [TInstall getInstall:^(NSDictionary * _Nullable data) {
            result([self gs_jsonStringCompactFormatForDictionary:data]);
        }];
    } else if ([@"registered" isEqualToString:call.method]) {
        [TInstall registered];
        result(nil);
    } else {
        result(FlutterMethodNotImplemented);
    }
}

- (NSString *)gs_jsonStringCompactFormatForDictionary:(NSDictionary *)dicJson {
    if (![dicJson isKindOfClass:[NSDictionary class]] || ![NSJSONSerialization isValidJSONObject:dicJson]) {
        return @"{}";
    }
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dicJson options:0 error:nil];
    NSString *strJson = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    return strJson;
}

@end
