import Flutter
import UIKit
import TInstallSDK

public class SwiftTinstallFlutterPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "tinstall_flutter_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftTinstallFlutterPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if "init" == call.method {
        let appKey:String = (call.arguments as! NSDictionary).value(forKey: "appKey") as! String
        TInstall.`init`(appKey)
        result(nil)
    } else if "setHost" == call.method {
        let host:String = (call.arguments as! NSDictionary).value(forKey: "host") as! String
        TInstall.setHost(host)
        result(nil)
    } else if "getInstall" == call.method {
        TInstall.getInstall { data in
            result(self.convertDictionaryToJSONString(dict:data as NSDictionary?))
        }
    } else if "registered" == call.method {
        TInstall.registered()
        result(nil);
    } else {
        result(FlutterMethodNotImplemented)
    }
  }

  func convertDictionaryToJSONString(dict:NSDictionary?) -> String {
        let data = try? JSONSerialization.data(withJSONObject: dict!, options: JSONSerialization.WritingOptions.init(rawValue: 0))
        let jsonStr = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)
        return jsonStr! as String
    }
}
